#ifndef __IUP_MGLPLOT_BI
#define __IUP_MGLPLOT_BI

/'* \file
 * \brief Plot component for Iup.
 *
 * See Copyright Notice in "iup.bi"
 '/
#include once "iup.bi"

extern "C" lib "iup_mglplot"

/' Initialize IupMglPlot widget class '/
declare sub   IupMglPlotOpen

/' Create an IupMglPlot widget instance '/
declare function IupMglPlot as Ihandle ptr

/'*********************************************'/
/'           Additional API                    '/

/' Linear Data Only '/
declare sub IupMglPlotBegin(byval as Ihandle ptr, byval dim_ as integer)
declare sub IupMglPlotAdd1D(byval as Ihandle ptr, byval name as const zstring ptr, byval y as double)
declare sub IupMglPlotAdd2D(byval as Ihandle ptr, byval x as double,byval y as double )
declare sub IupMglPlotAdd3D(byval as Ihandle ptr, byval x as double,byval y as double,byval z as double)
declare function IupMglPlotEnd(byval as Ihandle ptr) as integer

/' Linear (dim=1,2,3), Planar (dim=1), Volumetric (dim=1) '/
declare function IupMglPlotNewDataSet(byval as Ihandle ptr, byval dim_ as integer) as integer

/' Linear Data Only '/
declare sub IupMglPlotInsert1D(byval as Ihandle ptr, byval ds_index as integer, byval sample_index as integer, byval names as const zstring ptr ptr, byval y as const double ptr, byval count as integer)
declare sub IupMglPlotInsert2D(byval as Ihandle ptr, byval ds_index as integer, byval sample_index as integer, byval x as const double ptr, byval y as const double ptr, byval count as integer)
declare sub IupMglPlotInsert3D(byval as Ihandle ptr, byval ds_index as integer, byval sample_index as integer, byval x as const double ptr, byval y as const double ptr, byval z as const double ptr, byval count as integer)

/' Linear Data Only '/
declare sub IupMglPlotSet1D(byval as Ihandle ptr, byval ds_index as integer, byval names as const zstring ptr ptr, byval y as const double ptr, byval count as integer)
declare sub IupMglPlotSet2D(byval as Ihandle ptr, byval ds_index as integer, byval x as const double ptr, byval y as const double ptr, byval count as integer)
declare sub IupMglPlotSet3D(byval as Ihandle ptr, byval ds_index as integer, byval x as const double ptr, byval y as const double ptr, byval z as const double ptr, byval count as integer)
declare sub IupMglPlotSetFormula(byval as Ihandle ptr, byval ds_index as integer, byval formulaX as const zstring ptr, byval formulaY as const zstring ptr, byval formulaZ as const zstring ptr, byval count as integer)

/' Linear (dim=1), Planar (dim=1), Volumetric (dim=1) '/
declare sub IupMglPlotSetData(byval as Ihandle ptr, byval ds_index as integer, byval data as const double ptr, byval x_count as integer, byval y_count as integer, byval z_count as integer)
declare sub IupMglPlotLoadData(byval as Ihandle ptr, byval ds_index as integer, byval filename as const zstring ptr, byval x_count as integer, byval y_count as integer, byval z_count as integer)
declare sub IupMglPlotSetFromFormula(byval as Ihandle ptr, byval ds_index as integer, byval formula as const zstring ptr, byval x_count as integer, byval y_count as integer, byval z_count as integer)

/' Only inside callbacks '/
declare sub IupMglPlotTransform(byval as Ihandle ptr, byval x as double,byval y as double,byval z as double, byval ix as integer ptr, byval iy as integer ptr)
declare sub IupMglPlotTransformTo(byval as Ihandle ptr, byval ix as integer, byval iy as integer, byval x as double ptr,byval y as double ptr,byval as double ptr)

/' Only inside callbacks '/
declare sub IupMglPlotDrawMark(byval as Ihandle ptr, byval x as double,byval y as double,byval z as double)
declare sub IupMglPlotDrawLine(byval as Ihandle ptr, byval x1 as double,byval y1 as double,byval z1 as double, byval x2 as double,byval y2 as double,byval z2 as double)
declare sub IupMglPlotDrawText(byval as Ihandle ptr, byval txt as const zstring ptr, byval x as double,byval y as double,byval z as double)

declare sub IupMglPlotPaintTo(byval as Ihandle ptr, byval format as const zstring ptr, byval w as integer, byval h as integer, byval dpi as double, byval data as any ptr)


end extern

#endif ' __IUP_MGLPLOT_BI

