#ifndef __IUPCBS_BI
#define __IUPCBS_BI

/'* \file
 * \brief Contains all function pointer typedefs.
 *
 * See Copyright Notice in "iup.bi"
 '/

extern "C"

type IFidle as function as integer  /' idle '/

type IFii as sub (byval as integer, byval as integer) /' globalkeypress_cb '/
type IFiis as sub (byval as integer, byval as integer, byval as zstring ptr)  /' globalmotion_cb '/
type IFiiiis as sub (byval as integer, byval as integer, byval as integer, byval as integer, byval as zstring ptr) /' globalbutton_cb '/
type IFfiis as sub (byval as single,byval as integer,byval as integer,byval as zstring ptr)  /' globalwheel_cb '/

type IFn as function (byval as Ihandle ptr) as integer  /' default definition, same as Icallback '/
type IFni as function (byval as Ihandle ptr, byval as integer) as integer   /' k_any, show_cb, toggle_action, spin_cb, branchopen_cb, branchclose_cb, executeleaf_cb, showrename_cb, rightclick_cb, extended_cb, height_cb, width_cb '/
type IFnii as function (byval as Ihandle ptr, byval as integer, byval as integer) as integer  /' resize_cb, caret_cb, matrix_mousemove_cb, enteritem_cb, leaveitem_cb, scrolltop_cb, dropcheck_cb, selection_cb, select_cb, switch_cb, scrolling_cb, vspan_cb, hspan_cb '/
type IFniii as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as integer) as integer /' trayclick_cb, edition_cb '/
type IFniiii as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as integer, byval as integer) as integer /' dragdrop_cb '/
type IFniiiiiiC as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as integer, byval as integer, byval as integer, byval as integer, byval as any ptr) as integer  /' draw_cb '/
type IFniiiiii as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as integer, byval as integer, byval as integer, byval as integer) as integer  /' OLD draw_cb '/

type IFnff as function (byval as Ihandle ptr, byval as single, byval as single) as integer    /' canvas_action, plotmotion_cb '/
type IFniff as function (byval as Ihandle ptr,byval as integer,byval as single,byval as single) as integer  /' scroll_cb '/
type IFnfiis as function (byval as Ihandle ptr,byval as single,byval as integer,byval as integer,byval as zstring ptr) as integer  /' wheel_cb '/

type IFnsCi as function (byval as Ihandle ptr, byval as zstring ptr, byval as any ptr, byval as integer) as integer  /' dragdata_cb '/
type IFnsCiii as function (byval as Ihandle ptr, byval as zstring ptr, byval as any ptr, byval as integer, byval as integer, byval as integer) as integer  /' dropdata_cb '/
type IFnsiii as function (byval as Ihandle ptr, byval as zstring ptr, byval as integer, byval as integer, byval as integer) as integer  /' dropfiles_cb '/

type IFnnii as function (byval as Ihandle ptr, byval as Ihandle ptr, byval as integer, byval as integer) as integer /' drop_cb '/
type IFnnn as function (byval as Ihandle ptr, byval as Ihandle ptr, byval as Ihandle ptr) as integer /' tabchange_cb '/
type IFnss as function (byval as Ihandle ptr, byval as zstring ptr, byval as zstring ptr) as integer  /' file_cb '/
type IFns as function (byval as Ihandle ptr, byval as zstring ptr) as integer  /' multiselect_cb '/
type IFnsi as function (byval as Ihandle ptr, byval as zstring ptr, byval as integer) as integer  /' copydata_cb '/
type IFnis as function (byval as Ihandle ptr, byval as integer, byval as zstring ptr) as integer  /' text_action, multiline_action, edit_cb, rename_cb '/
type IFnsii as function (byval as Ihandle ptr, byval as zstring ptr, byval as integer, byval as integer) as integer  /' list_action '/
type IFniis as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as zstring ptr) as integer  /' motion_cb, click_cb, value_edit_cb '/
type IFniiis as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as integer, byval as zstring ptr) as integer  /' touch_cb, dblclick_cb '/
type IFniiiis as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as integer, byval as integer, byval as zstring ptr) as integer  /' button_cb, matrix_action, mousemotion_cb '/
type IFniiiiiis as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as integer, byval as integer, byval as integer, byval as integer, byval as zstring ptr) as integer  /' mouseclick_cb '/

type _IFnIi as function (byval as Ihandle ptr, byval as integer ptr, byval as integer) as integer /' multiselection_cb, multiunselection_cb '/
type IFnd as function (byval as Ihandle ptr, byval as double) as integer  /' mousemove_cb, button_press_cb, button_release_cb '/
type IFniiIII as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as integer ptr, byval as integer ptr, byval as integer ptr) as integer /' fgcolor_cb, bgcolor_cb '/
type IFniinsii as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as Ihandle ptr, byval as zstring ptr, byval as integer, byval as integer) as integer /' dropselect_cb '/
type IFnccc as function (byval as Ihandle ptr, byval as ubyte, byval as ubyte, byval as ubyte) as integer /' drag_cb, change_cb '/
type _IFniIIII as function (byval as Ihandle ptr, byval as integer, byval as integer ptr, byval as integer ptr, byval as integer ptr, byval as integer ptr) as integer /' multitouch_cb '/

type IFnC as function (byval as Ihandle ptr, byval as any ptr) as integer /' postdraw_cb, predraw_cb '/
type IFniiff as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as single, byval as single) as integer /' delete_cb '/
type IFniiffi as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as single, byval as single, byval as integer) as integer /' select_cb '/
type IFniiffff as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as single, byval as single, byval as single ptr, byval as single ptr) as integer /' edit_cb '/
type IFniiffs as function (byval as Ihandle ptr, byval as integer, byval as integer, byval as single, byval as single, byval as zstring ptr) as integer  /' plotbutton_cb '/

type sIFnii as function (byval as Ihandle ptr, byval as integer, byval as integer) as zstring ptr  /' value_cb, font_cb '/
type sIFni as function (byval as Ihandle ptr, byval as integer) as zstring ptr  /' cell_cb '/

type dIFnii as function (byval as Ihandle ptr, byval as integer, byval as integer) as double  /' numericgetvalue_cb '/
type IFniid as sub (byval as Ihandle ptr, byval as integer, byval as integer, byval as double)  /' numericsetvalue_cb '/

end extern

#endif ' __IUPCBS_BI

