#ifndef __IUPCONTROLS_BI 
#define __IUPCONTROLS_BI

/'* \file
 * \brief initializes dial, gauge, colorbrowser, colorbar controls.
 *
 * See Copyright Notice in "iup.bi"
 '/

extern "C"

declare function IupControlsOpen as integer

declare function IupColorbar as Ihandle ptr
declare function IupCells as Ihandle ptr
declare function IupColorBrowser as Ihandle ptr
declare function IupGauge as Ihandle ptr
declare function IupDial(byval typ as const zstring ptr) as Ihandle ptr
declare function IupMatrix(byval action as const zstring ptr) as Ihandle ptr
declare function IupMatrixList as Ihandle ptr

/' IupMatrix utilities (DEPRECATED, use IupSetAttributeId2 functions). It will be removed in a future version. '/
declare sub      IupMatSetAttribute  (byval as Ihandle ptr, byval name as const zstring ptr, byval lin as integer, byval col as integer, byval value as const zstring ptr)
declare sub      IupMatStoreAttribute(byval as Ihandle ptr, byval name as const zstring ptr, byval lin as integer, byval col as integer, byval value as const zstring ptr)
declare function IupMatGetAttribute  (byval as Ihandle ptr, byval name as const zstring ptr, byval lin as integer, byval col as integer) as zstring ptr 
declare function IupMatGetInt        (byval as Ihandle ptr, byval name as const zstring ptr, byval lin as integer, byval col as integer) as integer
declare function IupMatGetFloat      (byval as Ihandle ptr, byval name as const zstring ptr, byval lin as integer, byval col as integer) as single
declare sub      IupMatSetfAttribute (byval as Ihandle ptr, byval name as const zstring ptr, byval lin as integer, byval col as integer, byval format as const zstring ptr, ...)

end extern

/' Used by IupColorbar '/
#define IUP_PRIMARY -1
#define IUP_SECONDARY -2


#endif __IUPCONTROLS_BI

