#ifndef __IUPGL_BI
#define __IUPGL_BI

/'* \file
 * \brief OpenGL canvas for Iup.
 *
 * See Copyright Notice in "iup.h"
 '/

#include once "GL/gl.bi"

#include once "iup.bi"

extern "C" lib "iupgl"

/' Attributes 
** To set the appropriate visual (pixel format) the following
** attributes may be specified. Their values should be set
** before the canvas is mapped to the screen.
** After mapping, changing their values has no effect.
'/

#ifndef IUP_BUFFER    /' IUP_SINGLE (default) or IUP_DOUBLE '/
#define IUP_BUFFER    "BUFFER"
#endif

#ifndef IUP_STEREO    /' IUP_NO (default) or IUP_YES '/
#define IUP_STEREO     "STEREO"
#endif

#ifndef IUP_BUFFER_SIZE    /' Number of bits if index mode '/
#define IUP_BUFFER_SIZE    "BUFFER_SIZE"
#endif

#ifndef IUP_RED_SIZE    /' Number of red bits '/
#define IUP_RED_SIZE    "RED_SIZE"
#endif

#ifndef IUP_GREEN_SIZE    /' Number of green bits '/
#define IUP_GREEN_SIZE    "GREEN_SIZE"
#endif

#ifndef IUP_BLUE_SIZE    /' Number of blue bits '/
#define IUP_BLUE_SIZE    "BLUE_SIZE"
#endif

#ifndef IUP_ALPHA_SIZE    /' Number of alpha bits '/
#define IUP_ALPHA_SIZE    "ALPHA_SIZE"
#endif

#ifndef IUP_DEPTH_SIZE    /' Number of bits in depth buffer '/
#define IUP_DEPTH_SIZE    "DEPTH_SIZE"
#endif

#ifndef IUP_STENCIL_SIZE  /' Number of bits in stencil buffer '/
#define IUP_STENCIL_SIZE  "STENCIL_SIZE"
#endif

#ifndef IUP_ACCUM_RED_SIZE  /' Number of red bits in accum. buffer '/
#define IUP_ACCUM_RED_SIZE  "ACCUM_RED_SIZE"
#endif

#ifndef IUP_ACCUM_GREEN_SIZE  /' Number of green bits in accum. buffer '/
#define IUP_ACCUM_GREEN_SIZE  "ACCUM_GREEN_SIZE"
#endif

#ifndef IUP_ACCUM_BLUE_SIZE  /' Number of blue bits in accum. buffer '/
#define IUP_ACCUM_BLUE_SIZE  "ACCUM_BLUE_SIZE"
#endif

#ifndef IUP_ACCUM_ALPHA_SIZE  /' Number of alpha bits in accum. buffer '/
#define IUP_ACCUM_ALPHA_SIZE  "ACCUM_ALPHA_SIZE"
#endif


/' Attribute values '/
#ifndef IUP_DOUBLE
#define IUP_DOUBLE  "DOUBLE"
#endif
#ifndef IUP_SINGLE
#define IUP_SINGLE  "SINGLE"
#endif
#ifndef IUP_INDEX
#define IUP_INDEX  "INDEX"
#endif
#ifndef IUP_RGBA
#define IUP_RGBA  "RGBA"
#endif
#ifndef IUP_YES
#define IUP_YES    "YES"
#endif
#ifndef IUP_NO
#define IUP_NO    "NO"
#endif

declare sub      IupGLCanvasOpen
declare function IupGLCanvas(byval action as const zstring ptr) as Ihandle ptr
declare sub      IupGLMakeCurrent(byval as Ihandle ptr)
declare function IupGLIsCurrent(byval as Ihandle ptr) as integer
declare sub      IupGLSwapBuffers(byval as Ihandle ptr)
declare sub      IupGLPalette(byval as Ihandle ptr, byval index as integer, byval r as single, byval g as single, byval b as single)
declare sub      IupGLUseFont(byval as Ihandle ptr, byval first as integer, byval count as integer, byval list_base as integer)
declare sub      IupGLWait(byval gl as integer)

end extern


#endif ' __IUPGL_BI

