
#include once "inc/iup.bi"
'==============================================================================
'helper functions that make it easier to write and follow in my opinion
'------------------------------------------------------------------------------
Sub AddChild(ByVal parent As Ihandle Ptr, Byval child As Ihandle Ptr)
    IupAppend(parent,child)
    IupRefresh(parent)
End Sub
'==============================================================================
Function Create(Byval Value As String, Byval Attr As String,Byval Parent As Ihandle Ptr=0) As Ihandle Ptr
    var hWnd = IupCreate(Value)
    If hWnd Then
        If Len(Attr) Then
            IupSetAttributes(hWnd,Attr)
        End If
        If Parent Then
            AddChild(Parent,hWnd)
        End If    
    End If
    Function = hWnd
End Function
'==============================================================================
'fetch button callback
Function btnFetch_cb cdecl(byval handler As Ihandle Ptr) As Integer
    Dim szFile As zString * 256
    szFile = "*.txt"
    Select Case IupGetFile(szFile)
        Case 1
            IupMessage("New File",szFile)
        Case 0
            IupMessage("File already exists",szFile)
        Case -1
            IupMessage("IupFileDlg","Operation canceled")    
        Case -2
            IupMessage("IupFileDlg","Allocation error")
        Case -3
            IupMessage("IupFileDlg","Invalid parameter")
           
    End Select
    Function = IUP_DEFAULT
End Function
'==============================================================================
'Exit Button Callback
Function quit_cb cdecl(byval handler As Ihandle Ptr) As Integer
  Function = IUP_CLOSE
End Function
'==============================================================================
'About button callback
Function btnAbout_cb cdecl(byval handler As Ihandle Ptr) As Integer
    Dim s As zString Ptr
    s = IupVersion()
    IupMessage("IupVersion",(s))
    Function = IUP_DEFAULT
End Function

'==============================================================================
If (IupOpen(0,0)) = IUP_ERROR Then
  Print "Initialize Failed"
  End 1
End If  

'Create Main Window
    var win = Create("dialog","TITLE=Thesaurus, SIZE=500x300",0)
    'create container to house ALL GUI objects
    var vbox = Create("vbox","MARGIN=10x10",0)
    'Create Server panel
     var topBox = Create("hbox", " GAP=10", vbox)
      var serverFrame = Create("frame", "TITLE=Servers, EXPAND=YES", topBox)
       var serverBox = Create("hbox", "GAP=5", serverFrame)
        var serverCombo = Create("list", "DROPDOWN=YES, SIZE=120x, EXPAND=HORIZONTAL, VALUE=1", serverBox)
        var btnFetch = Create("button", "TITLE=Fetch, SIZE = 50x", serverBox)
        IupSetCallback(btnFetch, "ACTION", @btnFetch_cb)
    'Create control panel
      var controlFrame = Create("frame", "TITLE=Controls", topBox)
       var controlBox = Create("hbox", "Margin=6x6, GAP=5", controlFrame)
        var btnAbout = Create("button", "TITLE=About, SIZE = 50x", controlBox)
        var btnClear = Create("button", "TITLE=Clear, SIZE = 50x", controlBox)
        var btnExit = Create("button", "TITLE=Exit, SIZE = 50x", controlBox)
        'SETUP CALLBACK FOR EXIT BUTTON
        IupSetCallback(btnExit, "ACTION", @quit_cb)
        IupSetCallback(btnAbout, "ACTION", @btnAbout_cb)
    'Create dictionary panel
     var dictFrame = Create("frame", "TITLE=Dictionaries", vbox)
      var serverList = Create("list", "EXPAND=YES, VISIBLELINES=1", dictFrame)
    'Create text part
     var transFrame = Create("frame", "TITLE=Translation", vbox)
      var text = Create("text", "MULTILINE=YES, EXPAND=YES", transFrame)
    'Create entry and search button
     var bottomBox = Create("hbox", "GAP=10", vbox)
      var label = Create("label", "TITLE=Enter Word to Search For: , SIZE=x12", bottomBox)
      var entry = Create("text", " EXPAND=HORIZONTAL",bottomBox)
      var btnSearch = Create("button","TITLE=Search, SIZE=50x", bottomBox)
      var chkAll = Create("toggle", "TITLE=ALL, VALUE=ON,SIZE=x12", bottomBox)
      var chkUTF = Create("toggle", "TITLE=UTF-8, SIZE=x12", bottomBox)
    'Add the main GUI container to the Window
    AddChild(win, vbox)

'Show the Window
IupShow(win)
IupSetFocus(btnFetch)

IupMainLoop()

IupClose()
